﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Joey.DbOperator;
using System.Data;
using GuYu.Todo.Entities;

namespace GuYu.Todo.Forms.BusinessCatalog
{
    class CatalogBusiness
    {
        private DataBase _db = new DataBase();
        /// <summary>
        /// 更改目录名称
        /// </summary>
        /// <param name="catalogId">目录ID</param>
        /// <param name="catalogName">目录新名称</param>
        internal void MondifyCatalogName(int catalogId, string catalogName)
        {
            string sql = string.Format("update T_Catalog set Catalog_Name = '{0}' where Catalog_Id = {1}", catalogName, catalogId);
            _db.ExecuteNonQuery(sql);
        }

        /// <summary>
        /// 删除目录
        /// </summary>
        /// <param name="currentCatalogId">目录ID</param>
        internal void DeleteCatalog(int catalogId)
        {
            //删除目录
            string sqlDeleteCatalog = string.Format("delete from T_Catalog where Catalog_Id = {0}", catalogId);
            _db.ExecuteNonQuery(sqlDeleteCatalog);
            //删除目录下内容
            string sqlDeleteContent = string.Format("delete from T_CONTENT where Catalog_Id = '{0}'", catalogId);
            _db.ExecuteNonQuery(sqlDeleteContent);
            //删除子目录
            string sqlGetChildCatalogId = string.Format("select Catalog_Id from T_Catalog where Par_Id = {0}", catalogId);
            DataTable dt = _db.ExecuteDataTable(sqlGetChildCatalogId);
            foreach (DataRow item in dt.Rows)
            {
                this.DeleteCatalog(Convert.ToInt32(item[0]));
            }
        }

        /// <summary>
        /// 保存新目录
        /// </summary>
        /// <param name="newCatalog">新目录</param>
        internal void SaveCatalog(Entities.Catalog newCatalog)
        {
            int catalogId = PublicUnit.KeyHelper.GetPk("T_Catalog");
            newCatalog.Catalog_Id = catalogId;
            string sql = string.Format("insert into T_Catalog (Catalog_Id, Catalog_Name, Par_Id) values ({0},'{1}',{2})", catalogId, newCatalog.Catalog_Name, newCatalog.Par_Id);
            _db.ExecuteNonQuery(sql);
        }

        /// <summary>
        /// 获取所有的目录数据
        /// </summary>
        /// <returns></returns>
        internal List<Catalog> GetCatalogSet()
        {
            List<Catalog> catalogSet = new List<Catalog>();
            string sql = "select * from T_Catalog";
            IDataReader reader = _db.ExecuteReader(sql);
            while (reader.Read())
            {
                Catalog catalog = new Catalog();
                catalog.Catalog_Id = Convert.ToInt32(reader["Catalog_Id"]);
                catalog.Catalog_Name = reader["Catalog_Name"].ToString();
                catalog.Par_Id = Convert.ToInt32(reader["Par_Id"]);
                catalogSet.Add(catalog);
            }
            _db.CloseConnection();
            return catalogSet;
        }

        /// <summary>
        /// 新建跟目录
        /// </summary>
        /// <returns></returns>
        internal Entities.Catalog CreateRootCatalog()
        {
            int catalogId = PublicUnit.KeyHelper.GetPk("T_Catalog");
            string sql = string.Format("insert into T_Catalog (Catalog_Id, Catalog_Name, Par_Id) values ({0},'{1}',{2})", catalogId, "根目录", -1);
            _db.ExecuteNonQuery(sql);
            Catalog rootCatalog = new Catalog();
            rootCatalog.Catalog_Id = catalogId;
            rootCatalog.Catalog_Name = "根目录";
            rootCatalog.Par_Id = -1;
            return rootCatalog;
        }

        /// <summary>
        /// 查询根目录
        /// </summary>
        /// <returns>根目录</returns>
        internal Catalog GetRootCatalog()
        {
            Catalog rootCatalog = new Catalog();
            string sql = "select * from T_Catalog where Par_Id = -1";
            IDataReader reader = _db.ExecuteReader(sql);
            while (reader.Read())
            {
                rootCatalog.Catalog_Id = Convert.ToInt32(reader["Catalog_Id"]);
                rootCatalog.Catalog_Name = reader["Catalog_Name"].ToString();
                rootCatalog.Par_Id = Convert.ToInt32(reader["Par_Id"]);
            }
            _db.CloseConnection();
            return rootCatalog;
        }
    }
}
