﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Joey.DbOperator;
using System.Data.Common;
using GuYu.Todo.Entities;
using System.Data;
using System.ComponentModel;

namespace GuYu.Todo.Forms.BusinessContent
{
    class ContentBusiness
    {
        private DataBase _db = new DataBase();

        /// <summary>
        /// 修改状态
        /// </summary>
        /// <param name="contentId">主键</param>
        /// <param name="state">状态</param>
        internal void MondifyState(int contentId, string state)
        {
            string sql = string.Format("update T_CONTENT set State = '{0}' where Content_Id = {1}", state, contentId);
            _db.ExecuteNonQuery(sql);
            string upDateSql = string.Empty;
            if (state == PublicEnums.State.完成.ToString())
            {
                upDateSql = string.Format("update T_CONTENT set Time_Finish = {0}", _db.GetParameterPrefix() + "finishTime");
                DbParameter p = _db.GetParameter();
                p.DbType = DbType.DateTime;
                p.ParameterName = _db.GetParameterPrefix() + "finishTime";
                p.Value = DateTime.Now;
                _db.ExecuteNonQuery(upDateSql, p);
            }
            else if (state == PublicEnums.State.未完成.ToString())
            {
                upDateSql = "update T_CONTENT set Time_Finish = null";
                _db.ExecuteNonQuery(upDateSql);
            }
        }

        /// <summary>
        /// 删除内容
        /// </summary>
        /// <param name="content"></param>
        internal void DeleteContent(Entities.Content content)
        {
            string sql = string.Format("delete from T_CONTENT where Content_Id = '{0}'", content.Content_Id);
            _db.ExecuteNonQuery(sql);
        }

        /// <summary>
        /// 更新内容
        /// </summary>
        /// <param name="content"></param>
        internal void Update(Entities.Content content)
        {
            string sql = string.Format(@"
update T_CONTENT set 
ContentTitle = '{0}',
ContentText = '{1}',
Time_Predict_Finish = {2},
Is_Exe_Notify = '{3}',
Exe_Path = '{4}',
Time_Notify = '{5}',
Interval_Days = '{6}'
where CONTENT_ID = {7}",content.ContentTitle,
                      content.ContentText,
                      _db.GetParameterPrefix() + "predictFinishTime",
                      content.Is_Exe_Notify,
                      content.Exe_Path,
                      content.Time_Notify,
                      content.Interval_Days,
                      content.Content_Id);
            DbParameter parameter = _db.GetParameter();
            parameter.DbType = System.Data.DbType.DateTime;
            parameter.ParameterName = _db.GetParameterPrefix() + "predictFinishTime";
            parameter.Value = content.Time_Predict_Finish;

            _db.ExecuteNonQuery(sql, parameter);
        }

        /// <summary>
        /// 保存新建的内容
        /// </summary>
        /// <param name="newContent"></param>
        internal void Save(Entities.Content newContent)
        {
            int id = PublicUnit.KeyHelper.GetPk("T_CONTENT");
            string sql = string.Format(@"
insert into T_CONTENT
(
Content_Id,ContentTitle,ContentText,Time_Create,Time_Predict_Finish,Catalog_Id,State,Is_Exe_Notify,Exe_Path,Time_Notify,Interval_Days
)
values
(
{0},'{1}','{2}',{3},{4},{5},'{6}',{7},'{8}',{9},{10}
)", id, newContent.ContentTitle, newContent.ContentText, _db.GetParameterPrefix() + "timeCreate", _db.GetParameterPrefix() + "predictFinishTime", newContent.Catalog_Id, newContent.State, newContent.Is_Exe_Notify, newContent.Exe_Path, newContent.Time_Notify, newContent.Interval_Days);

            DbParameter timeCreateP = _db.GetParameter();
            timeCreateP.DbType = System.Data.DbType.DateTime;
            timeCreateP.ParameterName = _db.GetParameterPrefix() + "timeCreate";
            timeCreateP.Value = newContent.Time_Create;

            DbParameter predictFinishTimeP = _db.GetParameter();
            predictFinishTimeP.DbType = System.Data.DbType.DateTime;
            predictFinishTimeP.ParameterName = _db.GetParameterPrefix() + "predictFinishTime";
            predictFinishTimeP.Value = newContent.Time_Predict_Finish;

            _db.ExecuteNonQuery(sql, timeCreateP, predictFinishTimeP);
        }

        /// <summary>
        /// 获取内容数据
        /// </summary>
        /// <param name="fromDateTime">开始时间</param>
        /// <param name="toDateTime">结束时间</param>
        /// <param name="catalogId">目录ID</param>
        /// <param name="contentTitle">内容标题</param>
        /// <param name="state">状态</param>
        /// <param name="fromIndex">开始索引</param>
        /// <param name="count">条数</param>
        /// <param name="totalCount">总条数</param>
        /// <returns>数据集</returns>
        internal BindingList<Content> GetContent(DateTime fromDateTime, DateTime toDateTime, int catalogId, string contentTitle, string state, int fromIndex, int count, out int totalCount)
        {
            BindingList<Content> list = new BindingList<Content>();
            string sqlFilter = string.Format(@"
where
Time_Create >= {0}
and Time_Create <= {1}
and Catalog_Id = {2}
and ContentTitle like '%{3}%'
",_db.GetParameterPrefix() + "fromTime",
 _db.GetParameterPrefix() + "toTime",
 catalogId,
 contentTitle);
            if (state != "全部")
            {
                sqlFilter += string.Format(" and State = '{0}'", state);
            }
            DbParameter fromDateTomeP = _db.GetParameter();
            fromDateTomeP.DbType = DbType.DateTime;
            fromDateTomeP.ParameterName = _db.GetParameterPrefix() + "fromTime";
            fromDateTomeP.Value = fromDateTime;

            DbParameter toDateTimeP = _db.GetParameter();
            toDateTimeP.DbType = DbType.DateTime;
            toDateTimeP.ParameterName = _db.GetParameterPrefix() + "toTime";
            toDateTimeP.Value = toDateTime;

            DataSet ds = _db.ExecuteDataSet("select * from T_CONTENT " + sqlFilter, fromIndex, count, fromDateTomeP, toDateTimeP);
            totalCount = Convert.ToInt32(_db.ExecuteScalar("select count(*) from T_CONTENT " + sqlFilter, fromDateTomeP, toDateTimeP));

            foreach (DataRow item in ds.Tables[0].Rows)
            {
                Content t = new Content();
                t.Catalog_Id = Convert.ToInt32(item["Catalog_Id"]);
                t.Content_Id = Convert.ToInt32(item["Content_Id"]);
                t.ContentText = item["ContentText"].ToString();
                t.ContentTitle = item["ContentTitle"].ToString();
                t.Exe_Path =  item["Exe_Path"].ToString();
                t.Interval_Days = Convert.ToInt32(item["Interval_Days"]);
                t.Is_Exe_Notify = Convert.ToInt32(item["Is_Exe_Notify"]);
                t.State = item["State"].ToString();
                t.Time_Create = Convert.ToDateTime(item["Time_Create"]);
                if (item["Time_Finish"] != DBNull.Value)
                {
                    t.Time_Finish = Convert.ToDateTime(item["Time_Finish"]);
                }
                t.Time_Notify = Convert.ToInt32(item["Time_Notify"]);
                t.Time_Predict_Finish = Convert.ToDateTime(item["Time_Predict_Finish"]);
                list.Add(t);
            }
            return list;
        }

        /// <summary>
        /// 获取统计信息
        /// </summary>
        /// <returns></returns>
        internal DataTable GetStatisticsDt(DateTime from, DateTime to)
        {
            string sql = string.Format(@"
select count(*) as count,state 
from t_content
where 1=1
and Time_Create >= {0}
and Time_Create <= {1}
group by state ", _db.GetParameterPrefix() + "from", _db.GetParameterPrefix() + "to");
            DbParameter fromP = _db.GetParameter();
            fromP.DbType = DbType.DateTime;
            fromP.ParameterName = _db.GetParameterPrefix() + "from";
            fromP.Value = from;

            DbParameter toP = _db.GetParameter();
            toP.DbType = DbType.DateTime;
            toP.ParameterName = _db.GetParameterPrefix() + "to";
            toP.Value = to;

            return _db.ExecuteDataTable(sql, fromP, toP);
        }
    }
}
