﻿/*
 * author:Joey Zhao
 * date:2010-10-16 
 * describe：扫描是否存在已经过期的数据，如果有，将其设置为过期
 */
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Joey.DbOperator;
using System.Data.Common;
using System.Data;
using GuYu.Todo.Entities;

namespace GuYu.Todo.Forms.BusinessNotify
{
    public class ScanTimeOutDate
    {
        private DataBase _db = new DataBase();
        /// <summary>
        /// 扫描已过期的记录，改变其状态为“已过期”
        /// </summary>
        public void BeingScan()
        {
            DateTime now = DateTime.Now;
            string stateOver = PublicEnums.State.未完成.ToString();
            string stateTimeOut = PublicEnums.State.已过期.ToString();

            string sql = string.Format(@"select * from T_Content 
where Time_Predict_Finish < {0} 
and State = {1}", _db.GetParameterPrefix() + "timeNow", _db.GetParameterPrefix() + "state");

            DbParameter timeNowP = _db.GetParameter();
            timeNowP.DbType = System.Data.DbType.DateTime;
            timeNowP.ParameterName = _db.GetParameterPrefix() + "timeNow";
            timeNowP.Value = now;

            DbParameter stateP = _db.GetParameter();
            stateP.DbType = System.Data.DbType.String;
            stateP.ParameterName = _db.GetParameterPrefix() + "state";
            stateP.Value = stateOver;

            DataTable dt = _db.ExecuteDataTable(sql, timeNowP, stateP);
            dt.TableName = "T_Content";

            foreach (DataRow item in dt.Rows)
            {
                item["State"] = stateTimeOut;
            }
            _db.SaveDataTable(dt);
        }
    }
}
