﻿/*
 * aurhor:Joey Zhao
 * date:2010-10-3
 * describe:statistics form
 */
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using WeifenLuo.WinFormsUI.Docking;
using System.Configuration;
using System.IO;

namespace GuYu.Todo.Forms
{
    public partial class FormNote : DockContent
    {
        public FormNote()
        {
            InitializeComponent();
            this.richTextBox1.Dock = DockStyle.Fill;
            this.richTextBox1.Font = new Font("宋体", 12);
            this.richTextBox1.TextChanged += new EventHandler(richTextBox1_TextChanged);
            this.richTextBox1.MouseDown += new MouseEventHandler(richTextBox1_MouseDown);
            this.toolStripButtonBold.Click += new EventHandler(toolStripButtonBold_Click);
            this.toolStripButtonItalic.Click += new EventHandler(toolStripButtonItalic_Click);
            this.toolStripButtonUnderLine.Click += new EventHandler(toolStripButtonUnderLine_Click);
            this.toolStripButtonStrikeout.Click += new EventHandler(toolStripButtonStrikeout_Click);
            this.toolStripButtonFontColor.Click += new EventHandler(toolStripButtonFontColor_Click);
            this.toolStripButtonBackColor.Click += new EventHandler(toolStripButtonBackColor_Click);
            this.toolStripComboBoxSize.SelectedIndexChanged += new EventHandler(toolStripComboBoxSize_SelectedIndexChanged);
            this.Load += new EventHandler(FormNote_Load);
        }

        //在load事件里加载文件
        private void FormNote_Load(object sender, EventArgs e)
        {
            this.richTextBox1.TextChanged -= new EventHandler(richTextBox1_TextChanged);
            string rootPath = Application.StartupPath;
            string filePath = ConfigurationManager.AppSettings["RtfFilePath"];
            if (File.Exists(rootPath + "\\" + filePath))
            {
                this.richTextBox1.LoadFile(rootPath + "\\" + filePath);
            }
            this.richTextBox1.TextChanged += new EventHandler(richTextBox1_TextChanged);
        }

        //字体大小
        private void toolStripComboBoxSize_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (this.richTextBox1.SelectionFont == null)
            {
                return;
            }
            if (this.toolStripComboBoxSize.Text == string.Empty)
            {
                return;
            }
            this.richTextBox1.SelectionFont = new Font((new FontFamily("宋体")), Convert.ToSingle(this.toolStripComboBoxSize.Text),this.richTextBox1.SelectionFont.Style);
        }

        //鼠标点击时触发
        private void richTextBox1_MouseDown(object sender, MouseEventArgs e)
        {
            if (this.richTextBox1.SelectionFont == null)
            {
                return;
            }
            this.toolStripComboBoxSize.Text = this.richTextBox1.SelectionFont.Size.ToString();
        }

        //背景颜色
        private void toolStripButtonBackColor_Click(object sender, EventArgs e)
        {
            if (this.colorDialog1.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                Color color = colorDialog1.Color;
                this.richTextBox1.SelectionBackColor = color;
            }
        }

        //字体颜色
        private void toolStripButtonFontColor_Click(object sender, EventArgs e)
        {
            if (this.colorDialog1.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                Color color = colorDialog1.Color;
                this.richTextBox1.SelectionColor = color;
            }
        }

        //删除线
        private void toolStripButtonStrikeout_Click(object sender, EventArgs e)
        {
            if (this.richTextBox1.SelectionFont == null)
            {
                return;
            }
            FontStyle style = FontStyle.Regular;
            if (this.richTextBox1.SelectionFont.Strikeout == false)
            {
                style = style | FontStyle.Strikeout;
            }
            if (this.richTextBox1.SelectionFont.Bold)
            {
                style = style | FontStyle.Bold;
            }
            if (this.richTextBox1.SelectionFont.Italic)
            {
                style = style | FontStyle.Italic;
            }
            if (this.richTextBox1.SelectionFont.Underline)
            {
                style = style | FontStyle.Underline;
            }
            this.richTextBox1.SelectionFont = new Font("宋体",this.richTextBox1.SelectionFont.Size, style);
        }

        //下划线
        private void toolStripButtonUnderLine_Click(object sender, EventArgs e)
        {
            if (this.richTextBox1.SelectionFont == null)
            {
                return;
            }
            FontStyle style = FontStyle.Regular;
            if (this.richTextBox1.SelectionFont.Underline == false)
            {
                style = style | FontStyle.Underline;
            }
            if (this.richTextBox1.SelectionFont.Bold)
            {
                style = style | FontStyle.Bold;
            }
            if (this.richTextBox1.SelectionFont.Italic)
            {
                style = style | FontStyle.Italic;
            }
            if (this.richTextBox1.SelectionFont.Strikeout)
            {
                style = style | FontStyle.Strikeout;
            }
            this.richTextBox1.SelectionFont = new Font(this.richTextBox1.SelectionFont, style);
        }

        //斜体显示
        private void toolStripButtonItalic_Click(object sender, EventArgs e)
        {
            if (this.richTextBox1.SelectionFont == null)
            {
                return;
            }
            FontStyle style = FontStyle.Regular;
            if (this.richTextBox1.SelectionFont.Italic == false)
            {
                style = style | FontStyle.Italic;
            }
            if (this.richTextBox1.SelectionFont.Bold)
            {
                style = style | FontStyle.Bold;
            }
            if (this.richTextBox1.SelectionFont.Underline)
            {
                style = style | FontStyle.Underline;
            }
            if (this.richTextBox1.SelectionFont.Strikeout)
            {
                style = style | FontStyle.Strikeout;
            }
            this.richTextBox1.SelectionFont = new Font(this.richTextBox1.SelectionFont, style);
        }

        //粗体显示
        private void toolStripButtonBold_Click(object sender, EventArgs e)
        {
            if (this.richTextBox1.SelectionFont == null)
            {
                return;
            }
            FontStyle style = FontStyle.Regular;
            if (this.richTextBox1.SelectionFont.Bold == false)
            {
                style = style | FontStyle.Bold;
            }
            if (this.richTextBox1.SelectionFont.Italic)
            {
                style = style | FontStyle.Italic;
            }
            if (this.richTextBox1.SelectionFont.Underline)
            {
                style = style | FontStyle.Underline;
            }
            if (this.richTextBox1.SelectionFont.Strikeout)
            {
                style = style | FontStyle.Strikeout;
            }
            this.richTextBox1.SelectionFont = new Font(this.richTextBox1.SelectionFont, style);
        }

        //richTextBox1内容改变时触发
        private void richTextBox1_TextChanged(object sender, EventArgs e)
        {
            string rootPath = Application.StartupPath;
            string path = ConfigurationManager.AppSettings["RtfFilePath"];
            this.richTextBox1.SaveFile(rootPath + "\\" + path);
        }
    }
}
