﻿/*
 * author:Joey Zhao
 * date:2010-10-8
 */
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using GuYu.Todo.Entities;
using GuYu.Todo.Forms.BusinessNotify;
using GuYu.Todo.PublicUnit;

namespace GuYu.Todo.Forms
{
    public partial class FormNotify : Form
    {
        private Timer _timer;//倒计时
        private int _mintue;//倒计时秒数
        private NotifyEntity _entity;

        public FormNotify()
        {
            InitializeComponent();
            this.comboBoxMinitue.SelectedIndex = 0;
            _timer = new Timer();
            _timer.Interval = 1000;
            _mintue = 59;
            _timer.Tick += new EventHandler(_timer_Tick);
            this.Activated += new EventHandler(FormNotify_Activated);
            this.buttonOk.Click += delegate(object o, EventArgs e) { _timer.Stop(); this.Close(); };
            this.buttonNotifyLater.Click += new EventHandler(buttonNotifyLater_Click);
            this.buttonView.Click += new EventHandler(buttonView_Click);
            this.Load += new EventHandler(FormNotify_Load);
            this.FormClosing += new FormClosingEventHandler(FormNotify_FormClosing);
            this.labelClose.Click += new EventHandler(labelClose_Click);
            this.textBoxTitle.Select(0, 0);
        }

        //点击“关闭”
        private void labelClose_Click(object sender, EventArgs e)
        {
            _timer.Stop();
            _entity.NotifyTime += Convert.ToInt32(this.comboBoxMinitue.Text); 
            this.Close();
        }

        //淡出效果
        private void FormNotify_FormClosing(object sender, FormClosingEventArgs e)
        {
            FormHelper.AnimateWindow(this.Handle, 3000, FormHelper.AW_SLIDE | FormHelper.AW_HIDE | FormHelper.AW_BLEND);
        }

        //滑动效果
        private void FormNotify_Load(object sender, EventArgs e)
        {
            FormHelper.AnimateWindow(this.Handle, 2000, FormHelper.AW_SLIDE | FormHelper.AW_VER_NEGATIVE);
        }

        //点击查看详细信息按钮
        private void buttonView_Click(object sender, EventArgs e)
        {
            FormEdit form = new FormEdit();
            form.ShowDialog(_entity.NotifyContent, _entity.NotifyContent.Catalog_Id, PublicEnums.EditType.View);
        }

        //点击稍后提醒按钮
        private void buttonNotifyLater_Click(object sender, EventArgs e)
        {
            _timer.Stop();
            _entity.NotifyTime += Convert.ToInt32(this.comboBoxMinitue.Text);
            this.Close();
        }

        //倒计时Timer
        private void _timer_Tick(object sender, EventArgs e)
        {
            this.labelMinute.Text = _mintue.ToString();
            _mintue -= 1;
            if (_mintue == -1)
            {
                _timer.Stop();
                _entity.NotifyTime += Convert.ToInt32(this.comboBoxMinitue.Text);
                this.Close();
            }
        }

        //窗体打开时执行的内容
        private void FormNotify_Activated(object sender, EventArgs e)
        {
            _mintue = 59;
            this.textBoxTitle.Text = _entity.NotifyContent.ContentTitle;
            this.textBoxText.Text = _entity.NotifyContent.ContentText;
            _timer.Start();
            PlayMusic.Play(Application.StartupPath + "\\Music\\showForm.wav");
        }

        //显示窗体
        public void Show(NotifyEntity item)
        {
            _entity = item;
            this.Show();
        }
    }
}
