﻿/*
 * author:Joey Zhao
 * date:2010-10-17 
 * describe:catach some exception that not been captured
 */
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace GuYu.Todo.Forms
{
    public partial class FormShowException : Form
    {
        private readonly int CON_MIN_HEIGHT;//窗体的最小高度
        private readonly int CON_MAX_HEIGHT;//窗体的最大高度

        private readonly string CON_SHOW_DETAIL;//显示异常信息按钮Text
        private readonly string CON_HIDE_DETAIL;//隐藏异常信息按钮Text

        public FormShowException()
        {
            InitializeComponent();
            this.TopMost = true;
            this.StartPosition = FormStartPosition.CenterParent;
            this.textBoxException.ReadOnly = true;
            this.textBoxInfo.ReadOnly = true;
            this.textBoxInfo.Text = @"抱歉，软件运行错误，你可以自行修改源代码或联系作者。
www.cnglogs.com/zzy0471
i.joey.zhao@gmail.com）";
            CON_MAX_HEIGHT = 350;
            CON_MIN_HEIGHT = 158;
            CON_SHOW_DETAIL = "显示异常详细信息";
            CON_HIDE_DETAIL = "隐藏异常详细信息";
            this.buttonViewDetail.Text = CON_SHOW_DETAIL;
            this.buttonViewDetail.Click += new EventHandler(buttonViewDetail_Click);
        }

        //点击查询详细按钮
        private void buttonViewDetail_Click(object sender, EventArgs e)
        {
            if (this.buttonViewDetail.Text == CON_SHOW_DETAIL)
            {
                this.Height = CON_MAX_HEIGHT;
                this.buttonViewDetail.Text = CON_HIDE_DETAIL;
            }
            else
            {
                this.Height = CON_MIN_HEIGHT;
                this.buttonViewDetail.Text = CON_SHOW_DETAIL;
            }
        }

        /// <summary>
        /// 显示窗体
        /// </summary>
        /// <param name="e">要显示的异常</param>
        /// <returns></returns>
        public DialogResult ShowDialog(Exception e)
        {
            this.textBoxException.Text = e.Message + "\r\n" + e.StackTrace;
            this.textBoxInfo.Select(0, 0);
            return this.ShowDialog();
        }
    }
}
