﻿/*
 * author:Joey Zhao
 * date:2010-10-3 
 * descirbe:staticstics form
 */
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using WeifenLuo.WinFormsUI.Docking;
using System.Threading;
using System.Globalization;
using GuYu.Todo.Forms.BusinessContent;

namespace GuYu.Todo.Forms
{
    public partial class FormStatistics : DockContent
    {
        public FormStatistics()
        {
            InitializeComponent();
            this.buttonQeury.Click += new EventHandler(buttonQeury_Click);
            this.chart1.ChartAreas[0].Area3DStyle.Enable3D = true;
            this.chart1.Series[0].ChartType = System.Windows.Forms.DataVisualization.Charting.SeriesChartType.Pie;
        }

        //查询
        private void buttonQeury_Click(object sender, EventArgs e)
        {
            DateTime fromDate = this.dateTimePickerFrom.Value.Date;
            DateTime toDate = this.dateTimePickerTo.Value.Date.AddHours(23).AddMinutes(59).AddSeconds(59);
            if (fromDate > toDate)
            {
                PublicUnit.ControlsHelper.ShowInforMessage("开始时间不能大于结束时间！");
                this.dateTimePickerFrom.Focus();
                return;
            }

            DataTable result = new ContentBusiness().GetStatisticsDt(fromDate, toDate);
            this.chart1.DataSource = result;
            this.chart1.Series[0].YValueMembers = "Count";
            this.chart1.Series[0].XValueMember = "State";
            this.chart1.Series[0].IsValueShownAsLabel = true;
            this.chart1.DataBind();
        }
    }
}
