﻿/*
 * author:Jeoy Zhao
 * date:2010-10-6
 * describe: helper method of controls
 */
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace GuYu.Todo.PublicUnit
{
    public static class ControlsHelper
    {
        /// <summary>
        /// 用参数制定类型的枚举绑定ComboBox
        /// </summary>
        /// <param name="comboBox">要绑定的BomboBox</param>
        /// <param name="t">枚举类型</param>
        public static void BindComboBoxWithEnum(this ComboBox comboBox,Type t)
        {
            string[] array = Enum.GetNames(t);
            for (int i = 0; i < array.Length; i++)
            {
                comboBox.Items.Add(array[i]);
            }
        }
        
        /// <summary>
        /// 系统提示信息
        /// </summary>
        /// <param name="message">提示信息内容</param>
        public static void ShowInforMessage(string message)
        {
            MessageBox.Show(message,"系统提示");
        }

        /// <summary>
        /// 选择MessageBox
        /// </summary>
        /// <param name="message">提示信息内容</param>
        /// <param name="title">标题</param>
        /// <returns>Ok：true；Cancel：false</returns>
        public static bool ShowOkCancelMessage(string message, string title)
        {
            if (DialogResult.OK == MessageBox.Show(message,title,MessageBoxButtons.OKCancel))
            {
                return true;
            }
            return false;
        }
    }
}
