﻿/*
 * author:Joey
 * date:2011-1-10 
 * describe：ADO.Net数据库访问类实例化接口
 */
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.Common;

namespace Joey.DbOperator.ADODotNetFactory
{
    public abstract class AbsADODotNet
    {
        /// <summary>
        /// 获取一个数据库连接
        /// </summary>
        /// <returns>数据库连接实例</returns>
        public abstract DbConnection GetConnection();

        /// <summary>
        /// 获取一个数据库命令
        /// </summary>
        /// <returns>数据库命令实例</returns>
        public abstract DbCommand GetCommand();

        /// <summary>
        /// 获取一个ADO.Net适配器
        /// </summary>
        /// <returns>适配器实例</returns>
        public abstract DbDataAdapter GetDataAdapter();

        /// <summary>
        /// 获取一个数据库命令创建实例
        /// </summary>
        /// <returns>数据库命令创建实例</returns>
        public abstract DbCommandBuilder GetCommandBuilder();

        /// <summary>
        /// 获取一个数据库SQl语句参数类实例
        /// </summary>
        /// <returns>数据库SQl语句参数类实例</returns>
        public abstract DbParameter GetParameter();

        /// <summary>
        /// 获取参数前缀
        /// </summary>
        /// <returns>参数前缀</returns>
        public abstract string GetParameterPrefix();
    }
}
